'Egy BASIC mintaprogram a PICPLC8 panelre.
'Az A0 analog bemenet beolvassa, az eredmeny kiirja az LCD-re, es kivezerlesmerokent mukodteti az L0-7 LED-eket 

' Konfigurljuk a PORTA-t. Teht hogy melyik kivezetseket akarjuk digitlis, vagy 
' analg portnak hasznlni, mi legyen a mrs referencia feszltsge. 
' Ezeket az ANSELA-B-C-D, az ADCON0 s ADCON1 regiszterbe tlttt adat fogja meghatrozni. 
' Szval, ha azt akarjuk, hogy a PORTA.0-1-3 mint analog,
' a PORTA.2-4-5 mint digitlis port legyen hasznlva, a
' a mrs referencia feszltsge pedig a tpfesz legyen, akkor:

' Akr 14 lb hasznlhat analg bemenetnek, de most mind digitlis legyen:

   ANSELA = %00000000    ' porta mind digitlis
   ANSELB = %00000000    ' portb mind digitlis
   ANSELD = %00000000    ' portd mind digitlis
   ANSELE = %00000000    ' porte mind digitlis
   
    TRISC = %00000000	' A PORTC 0-7 output
   
	DEFINE LCD_DREG 	PORTD	' Az LCD adatbitek a D porton
	DEFINE LCD_DBIT 	0	' Az els bit az RD0
	DEFINE LCD_RSREG 	PORTD	' A register select bit a D porton,
	DEFINE LCD_RSBIT 	4	' az RD4 port
	DEFINE LCD_EREG 	PORTD	' Az enable bit a D porton,
	DEFINE LCD_EBIT 	5	' az RD5 portra van kiosztva
	DEFINE LCD_BITS 	4	' a 4 bites zemmodot valasztjuk
	DEFINE LCD_LINES 	2	' 2 soros az LCD
	
	lcdout $fe,1	    		' LCD torles, es iras az elso sorba
	lcdout "*** Mikroklub **"
	lcdout $fe,$C0	    		' LCD torles, es iras a masodik sorba
	lcdout "www.mikroklub.hu"

    PORTC.6 = 0     ' Bekapcsolom az LCD httrvilgtst
	
' A relek valtott ki/bekapcsolasa:

	W0 var Word
	B6 var byte
	
	STROBE var PORTB.5		' A 74HC4094 kimeneti beiro jele a PORTB.5,
	CLK var PORTB.7			' az orajele a PORTB.7,
	DAT var PORTB.6 		' az adat bemenete a PORTB.6-ra van kiosztva.
main:	FOR B6 = 1 TO 16 		' Az adatok beleptetese a sorba kotott 4094-ekbe
	Toggle DAT			' A relek sorban be-ki-be-ki-be...  lesznek kapcsolva
	HIGH CLK			' az orajelbemenet magasra kapcsolva 
	Pause 1				' egy kicsit magasan tartjuk
	LOW CLK 			' majd alacsony szintre kapcsolva egy oraimpulzust csinaltunk.
	NEXT B6				' Vissza a ciklusba, amig a 2x8=16 bit nincs beleptetve 

	HIGH STROBE			' A beleptetett adatokat a kimenetre kapcsoljuk, 
	Pause 1				' a "Strobe"-ra egy beiro jelet adunk.
	LOW STROBE 			' A 4094 kimeneten megjelennek a beleptetett adatok.

	Pause 3000			' 3000 msec, azaz 3 masodperc pause

	Toggle PORTA.4			' Az RA4 porton vezerelt LED ki/bekapcsolgatsa
	
	Toggle PORTC.0		' A PICPLC16-on van ktszn LED az RC0-RC1-en, ezt villogtatom
	PORTC.1 = ! PORTC.0
	
	Toggle DAT			' 
	
	goto main			' Kezdodik ujra 
	end
